chiark / gitweb /
dot/mykermrc, bin/guest-console: Kermit configuration.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile
137   ditz-config
138   mailrc signature
139   cgrc tigrc
140   gdbinit
141   guile
142   rcrc
143   toprc
144   kermrc
145   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
146   aspell.conf
147   tclshrc:.tclshrc tclshrc:.wishrc
148   lisp-init.lisp:.cmucl-init.lisp
149     lisp-init.lisp:.sbclrc
150     lisp-init.lisp:.clisprc.lisp
151     lisp-init.lisp:.eclrc
152   swank.lisp
153   dircolors colordiffrc screenrc cvsrc indent.pro"
154 [ "$xstuff" ] && dotfiles="$dotfiles
155   xinitrc xsession Xdefaults vncrc vncsession
156   fonts.conf
157   stalonetrayrc
158   putty-defaults:.putty/sessions/Default%20Settings
159   mdw.session:.config/gnome-session/sessions/mdw.session
160   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
161   e-keybindings.cfg:.enlightenment/keybindings.cfg
162   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
163   e16-bindings:.e16/bindings.cfg"
164 echo "Installing dotfiles..."
165 for d in $dotfiles; do
166   target=.$d
167   case $d in
168     *:*) target=${d#*:} d=${d%%:*};;
169   esac
170   ft=$HOME$sub/$target
171   dir=${ft%/*}
172   mkdir -p $dir
173   ln -s $here/dot/$d $ft.new
174   mv $ft.new $ft
175   echo "  $target"
176 done
177 echo "  all done."
178
179 ## Substitute things which need substituting.
180 dotfilessubst="
181   gitconfig
182   pulse-default.pa.in:.pulse/default.pa"
183 echo "Installing dotfiles with substitutions..."
184 for d in $dotfilessubst; do
185   case $d in
186     *:*) target=${d#*:} d=${d%%:*};;
187     *) target=.$d d=$d.in;;
188   esac
189   ft=$HOME$sub/$target
190   dir=${ft%/*}
191   mkdir -p $dir
192   sed "
193 1i\\
194 ### generated by $here/setup; do not edit!\\
195
196 /@home@/ s\a\a$HOME\ag
197 /@profile@/ s\a\a$here\ag
198 /@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
199 " dot/$d >$ft.new
200   mv $ft.new $ft
201   echo "  $target"
202 done
203 echo "  all done."
204
205 ## Symlink backgrounds.
206 backgrounds="
207   jue-peek.jpg
208   medusa.jpg
209   bsg-supper.jpg
210   rayne.jpg
211   hypatia.jpg
212   noodly.jpg
213   lovelace.jpg"
214 if [ "$xstuff" ]; then
215   echo "Installing backgrounds..."
216   for b in $backgrounds; do
217     for e in enlightenment e16; do
218       dir=$HOME$sub/.$e/backgrounds
219       t=$dir/$b
220       mkdir -p $dir
221       ln -s $here/bg/$b $t.new
222       mv $t.new $t
223     done
224     echo "  $b"
225   done
226   echo "        all done."
227 fi
228
229 ###--------------------------------------------------------------------------
230 ### Install useful scripts included in this package.
231
232 scripts="
233   mdw-editor
234   mdw-pager
235   mdw-conf
236   mdw-build
237   emacsclient-hack
238   movemail-hack
239   sendmail-hack
240   aspell-hack
241   emerge-hack
242   lesspipe.sh
243   start-ssh-agent
244   svnwrap
245   guest-console
246   hyperspec"
247 [ "$xstuff" ] && scripts="$scripts
248   xinitcmd
249   un-backslashify-selection
250   lock-screen
251   xshutdown"
252 echo "Installing scripts..."
253 mkdir -p $HOME$sub/bin
254 for s in $scripts; do
255   ft=$HOME$sub/bin/$s
256   ln -s $here/bin/$s $ft.new
257   mv $ft.new $ft
258   echo "  $s"
259 done
260 echo "  all done."
261
262 hacks="
263   ssh:ssh"
264 echo "Installing hacks..."
265 for h in $hacks; do
266   d=${h%%:*} h=${h#*:}
267   ft=$HOME$sub/bin/hacks/$d
268   mkdir -p $ft
269   ln -s $here/hacks/$h $ft/$h.new
270   mv $ft/$h.new $ft/$h
271   echo "  $d:$h"
272 done
273 echo "  all done."
274
275 ###--------------------------------------------------------------------------
276 ### Set up the Emacs config.
277
278 $echon "Finding a suitable emacs:$echoc"
279 emacs=no
280 for i in emacs22 emacs23 emacs21 emacs; do
281   if type -p >/dev/null $i; then
282     emacs=$i
283     break
284   fi
285 done
286 if [ $emacs = no ]; then
287   echo " failed."
288   emacs=:
289 else
290   echo " $emacs."
291 fi
292
293 echo "Installing Emacs packages..."
294 emacspkg="
295   make-regexp
296   ew-hols
297   mdw-gnus-patch
298   git git-blame vc-git stgit
299   quilt"
300 for elib in $emacspkg; do
301   $echon "  $elib:$echoc"
302   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
303        (progn
304          (setq load-path (nconc load-path (list "~/lib/emacs")))
305          (kill-emacs (condition-case nil
306                          (progn (load-library "'"$elib"'") 0)
307                        (error 1))))'; then
308     echo " already installed."
309   else
310     if [ -f el/$elib.el ]; then
311       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
312     else
313       $echon " downloading$echoc"
314       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
315     fi
316     $echon " compiling$echoc"
317     (cd $HOME$sub/lib/emacs;
318       $emacs >/dev/null 2>&1 --no-site-file --batch \
319         --eval '(byte-compile-file "'"$elib.el"'")')
320     echo " done."
321   fi
322 done
323 echo "  all done."
324
325 $echon "Setting up Emacs configuration:$echoc"
326 $echon " linking$echoc"
327 for f in dot-emacs.el Makefile; do
328   set -- $(echo $link | tr : ' ')
329   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
330   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
331 done
332 $echon " compiling$echoc"
333 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
334 echo " done."
335
336 ###----- That's all, folks --------------------------------------------------